<%@page contentType="text/html"%>
<%@page pageEncoding="UTF-8"%>
<%@page import="java.io.FileInputStream"%>
<%@page import="java.util.Properties"%>
<%@page import="com.swiveltechnologies.client.PINsafeClient"%>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
   "http://www.w3.org/TR/html4/loose.dtd">
 <%


   final String errorAttribute = "error";
   final String usernameAttribute ="username";
   final String idAttribute = "sessionid";
   final String passwordAttribute = "password";
   String PinPadImage = "http://localhost:8181/proxy/SCPinPad?username=";
   String introduction = "", usernamePrompt = "", newPassswordPrompt= "",existingPassswordPrompt= "", existingPrompt = "",newOTCPrompt ="", confirmNewOTCPrompt= "";
   String defaultError = "An error occured, please check your<br />credentials. If the error persists<br /> contact your PINsafe Administrator.";
   int init = 0, sessionStart = 1, changePin = 2, complete = 3;
   int status= changePin;

   String password = "", newPassword="", otc = "", newotc= "", error="", sessionID = "", username = "", ppsid="";
   String OTC = "", newOTC = "";
   PINsafeClient sc;
   String otcVisible = "display:none";
   boolean primary = false;
   Properties clientProps = new Properties();
   Properties prompts = new Properties();
//   Properties sessionProps = new Properties();

   if(session.getAttribute("status") == null){
   	status = init;
   }else {
   	if ((request.getParameter("sessionstart") != null) || new String("sessionstart").equals(request.getParameter("action"))) {
      		status = sessionStart;
   	} 
   }

   session.setAttribute("status", status);


   if(session.getAttribute("settings") == null){
       
   try {
	    FileInputStream is = new FileInputStream(
	            this.getServletContext().getRealPath("/WEB-INF/settings.xml"));
	    clientProps.loadFromXML(is);
	    sc = new PINsafeClient(clientProps);
	    if(sc.ping().equalsIgnoreCase("pass")){
	        primary = true;
	        session.setAttribute("settings", clientProps);
	    }
	} catch (Exception e) {
		error = e.getLocalizedMessage();
		
	} 
	if(!primary) {
	  try{
	    FileInputStream is = new FileInputStream(
	            this.getServletContext().getRealPath("/WEB-INF/settings2.xml"));
	    clientProps.loadFromXML(is);
	    sc = new PINsafeClient(clientProps);
	    if(sc.ping().equalsIgnoreCase("pass")){
	        session.setAttribute("settings", clientProps);
	    }
	  }catch (Exception e) {
			error = e.getLocalizedMessage();
			
		} 
	}
   } else {
       clientProps = (Properties)session.getAttribute("settings");
   }
   
   if (clientProps.getProperty("imagessl","false").equalsIgnoreCase("true")){
	PinPadImage="https://".concat(clientProps.getProperty("imageserver","localhost"));
	} else {
	PinPadImage="http://".concat(clientProps.getProperty("imageserver","localhost"));
	}
	PinPadImage= PinPadImage.concat(":").concat(clientProps.getProperty("imageport", "8080"));
	PinPadImage = PinPadImage.concat("/").concat(clientProps.getProperty("imagecontext", "proxy")).concat("/SCPinPad?username=");
	
   
	// read any parameters passed into the page
	// only allow username to passed in a GET
	//if not username passed in, read from the session
	if(request.getParameter(usernameAttribute) == null){
	    if(session.getAttribute("username") != null){
	        username = (String)session.getAttribute("username");
	    }
	    
	} else {
		username =  request.getParameter(usernameAttribute);
		username = (PINsafeClient.checkChars(username)? username : "");
		session.setAttribute("username", username);
	}
	//
	if(request.getMethod().equalsIgnoreCase("POST")){
	password = (request.getParameter(passwordAttribute) != null ? request.getParameter(passwordAttribute) : "");
	if(clientProps.getProperty("password","false").equalsIgnoreCase("true")){
		password = (request.getParameter("password") != null ? request.getParameter("password") : "");
	}
	
	if(clientProps.getProperty("changepassword","false").equalsIgnoreCase("true")){
		newPassword = (request.getParameter("newpassword") != null ? request.getParameter("newpassword") : "");
	}
	
	    
	    OTC = (request.getParameter("otc") != null ? request.getParameter("otc") : "");
	    newOTC = (request.getParameter("newotc") != null ? request.getParameter("newotc") : "");
	}
	    if(username.equals("")) {
	    	status = init;
	    }
	//Check to see what prompts are required.
	

	
	boolean explicit = false;
	
	 try {
		    FileInputStream is = new FileInputStream(
		            this.getServletContext().getRealPath("/WEB-INF/prompts.xml"));
		    prompts.loadFromXML(is);
	 } catch(Exception e){
	     error = e.getLocalizedMessage();
	 }
	
	 
	 if(prompts != null){

	     if(prompts.getProperty("introuction")!= null)
			   introduction = prompts.getProperty("introduction");
			else
				introduction = "Welcome to the changePIN application";
	     if(prompts.getProperty("usernamePrompt")!= null)
			    usernamePrompt = prompts.getProperty("usernamePrompt");
			else
				usernamePrompt = "Step 1: Enter your username and<br>press the Get Image button if you need a TURing image";
		  
	     if(prompts.getProperty("existingPasswordPrompt")!= null)
		    existingPassswordPrompt = prompts.getProperty("existingPasswordPrompt");
		else
			existingPassswordPrompt = new String("Step Enter any password");
	 
		if(clientProps.getProperty("explicit", "false").equalsIgnoreCase("true"))
		{
			explicit = true;
			
			if(prompts.getProperty("existingPrompt")!= null)
			    existingPrompt = prompts.getProperty("existingPrompt");
			else
				existingPrompt = new String("Enter your current PIN");
			if(prompts.getProperty("newOTCPrompt") != null)
			    newOTCPrompt = prompts.getProperty("newOTCPrompt");
			else
				newOTCPrompt = new String("Enter your new PIN");
		
			if(prompts.getProperty("confirmNewOTCPrompt") != null)
		    	confirmNewOTCPrompt = prompts.getProperty("confirmNewOTCPrompt");
			else
				confirmNewOTCPrompt = new String("Enter your new PIN");
		
		
		} else {

	    if(prompts.getProperty("existingPrompt")!= null)
		    existingPrompt = prompts.getProperty("existingPrompt");
		else
			existingPrompt = new String("Step 2 : Enter the OTC (one-time-code) using the PIN<br>your current PIN and the Security String shown below.");
	    
	   
		if(prompts.getProperty("newOTCPrompt") != null)
		    newOTCPrompt = prompts.getProperty("newOTCPrompt");
		else
			newOTCPrompt = new String("Step 3 : Enter the OTC using your<br>new PIN and the Security String.");
		
		if(prompts.getProperty("confirmNewOTCPrompt") != null)
		    confirmNewOTCPrompt = prompts.getProperty("confirmNewOTCPrompt");
		else
			confirmNewOTCPrompt = new String("Step 4 : Re-enter the OTC using your new PIN<br/>");
		
	    
	  
		
	}
	
	 }
	switch (status){
	case(0)://init
	    otcVisible = "display:none";
		break;
	
case(1)://session start

	 sc = new PINsafeClient(clientProps);
	    //Create an instance of the PINsafeClient and setup with he settings...
        if(PINsafeClient.checkChars(username)){
        
        //Attempt to create a session...
        sessionID = sc.startSession(username);
        ppsid=Integer.toString((int)(Math.ceil(10000*Math.random())));
        if(sessionID.length() == 0){
        	error = "Cannot start PINsafe Session";
        	session.setAttribute("error", error);
        } else {
        		error = "";
        		otcVisible = " ";
     
        	}
        } else {
        	error = "Invalid Characters in username";
        	session.setAttribute("error", error);
        }
		
	break;
	
case(2):
{
	
    sc = new PINsafeClient(clientProps);
	if(explicit) {
    	  sessionID = sc.startSession(username);
          String security = sc.getSecurityString(sessionID);
            if (!security.equals("")) {
                security = security + "0";
                String pin = OTC.concat("0");
                String newpin = newOTC.concat("0");
                //      determine one-time-code
                OTC = new String("");
                for (int c = 0; c < pin.length() - 1; c++) {
                    int index = Integer.parseInt(pin.substring(c, c+ 1));
                if (index == 0)
                    index = 9;
                        else
                    index--;
                OTC += security.substring(index, index + 1);
              }
                //determine new one-time-code
                newOTC = new String("");
                for (int c = 0; c < newpin.length() - 1; c++) {
                    int index = Integer.parseInt(newpin.substring(c, c + 1));
                    if (index == 0)
                        index = 9;
                    else
                        index--;
                    newOTC += security.substring(index, index + 1);
                }
            }
	}//end of explicit block
        //If no new password is entered, submit old
        if(newPassword.equals("")){
        	newPassword = password;
        }
	
    if (sc.changePIN(username, password, newPassword, OTC, newOTC)) {
    	status = complete;
    	session.setAttribute("status", init);
    	error = "";
    } else {
    	session.setAttribute("status", init);
            //Redirect user with error and username...
			error = sc.getError();
			if(error.toLowerCase().contains("composition")){
				if(error.toLowerCase().contains("pin")){
					error = "Your chosen PIN was not valid.<br />Please try again with a different PIN.<br />For more details contact your PINsafe Administrator";
				}else {
					error = "Your chosen Password was not valid.<br />Please try again with a different Password.<br />For more details contact your PINsafe Administrator";
				}
			} else { 
				if(error.toLowerCase().contains("password_mandatory")) {
					error = "You must supply a valid password";
				} else {
				error = defaultError;
				}
    	}
    }
}//end of changePIUN case
}// end of switch

%>

<%if(status != complete)  {%>

<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<link type="text/css" rel="stylesheet" href="./changepin.css">
<title>PINsafe Change PIN</title>
<style>
#blockbusters {
	width:200px;
	text-align: center;
}
	#middle {
		margin-top:-12px
	}
	#bottom {
		margin-top:-12px
	}
</style>

<script type="text/javascript" src="./changepin.js"></script>
<script>
function addOtc(digit){
	var otc;
	//alert(digit);
	if(digit=="10"){
		digit="0";
	}
	//alert(digit);
	otc = document.getElementById(field);
	otc.value = otc.value + digit;

}

function setppFocus(f){

switch (f){
	case (1): field = "otc";
			break;
	case (2): field ="newotc";
			break;
	case (3): field = "newotc2";
	break;
	
}
}

var PinPadImage = "http://localhost:8081/proxy/SCPinPad?username=";
</script>
</head>
<body onload="set_focus()">
<form method="post" id="changepin-form" 
	action="changepinpad.jsp">
	<input type="hidden" name="action"
	id="action" />
<table id="box">
	<tr id="username-row">
		<td colspan= "2" class="label"><%=introduction %></td>
	
	</tr>
	<tr id="username-row">
		<td class="label"><%=usernamePrompt %></td>
		

	<% if ((sessionID.length() > 0) && (!explicit)) {%>
	    <td class="text"><input name="username" id="username" type="text"
			value="<%=username%>" onchange="check_username();" readonly = "readonly"></td>	</tr>
  		
		<tr id="image-row">
		<td colspan="2">
		<div id="blockbusters">
		<% for(int i =1; i<=10; i++ ){
			String src=PinPadImage + username + "&padno=" + ppsid + ":" + i;
		%>
						<img id=<%=i %> src="<%=src%>"  onclick="addOtc(<%=i %>)" />
		<%if((i == 3)){ %>				
						<div id="middle">
		<%} else if(i == 7)  {%>
		</div>
		<div id="bottom">
		
	
	<%} }%>
	</div>
			</div>
	</td>
	</tr>		
	<tr id="otc-row">
		<td class="label"><%=existingPrompt%></td>
		<td class="text"><input name="otc" id="otc" type="password" onfocus="setppFocus(1)" value="<%=otc%>"> </td>
	</tr>
	
	
	<tr id="otc1-row" >
		<td class="label"><%=newOTCPrompt%></td>
		<td class="text"><input name="newotc" id="newotc" onfocus="setppFocus(2)" type="password" value="<%=newotc%>"></td>
	</tr>
	<tr id ="otc2-row">
		<td class="label" ><%=confirmNewOTCPrompt%></td>
		<td class="text"><input name="newotc2" id="newotc2" onfocus="setppFocus(3)"
			type="password"  ></td>
	</tr>
	
	
		
	
	<%  %>
	
	<% }  else {%>
			<td class="text"><input name="username" id="username" type="text"
			value="<%=username%>" onchange="check_username();" ></td>
	
	</tr>	
	<% } %>
	
	<%if(clientProps.getProperty("password", "false").equalsIgnoreCase("true"))
                {%>
	<tr id="password-row" style="<%=otcVisible%>">
		<td class="label"><%=existingPassswordPrompt%></td>
		<td class="text"><input name="password" id="password"
			type="password" value=""></td>
	</tr>
	<% } %>
	
	<%
	if(clientProps.getProperty("changepassword", "false").equalsIgnoreCase("true"))
                {%>
	<tr id>
		<td class="label">Step 5: If you are also changing your PINsafe password<br /> Enter New Password:</td>
		<td class="text"><input name="newpassword" id="newpassword"
			type="password"></td>
	</tr>
	<tr id>
		<td class="label">Step 6: Re-enter you new password<br /> Then select change PIN</td>
		<td class="text"><input name="newpassword2" id="newpassword2"
			type="password"></td>
	</tr>
	<% } %>
	<tr id="buttons-row">
		<td>&nbsp;</td>
		<td>
		<input name="clear" id="clear" type="submit" onclick="return clearFields(event);" value="Clear">&nbsp;
		<%if(explicit) { %> 
		
		<input name="sessionstart" id="sessionstart" type="submit"
			onclick="return check_username();" value="Next">&nbsp;
		
		<input name="changepin" id="changepin" type="submit"
			onclick="return check_pins(event);" value="Change PIN"> 

			<% } else {%>
		
		<input name="sessionstart" id="sessionstart" type="submit"
			onclick="return check_username()" value="Next">&nbsp;
		<input name="changepin" id="changepin" type="submit" onclick="return check_pins(event);" value="Change PIN">
			 <% } %>
		</td>
	</tr>

	
	<% if(error.length() > 0) { %>
	<tr id="error-row">
		<td colspan="2">
		<div><%=error %></div>
		
		</td>
	</tr>
	
	
	<% } %>
</table>
</form>
</body>
</html>
<%}  else {
	status = init;
	session.setAttribute("status", status);
	Properties props = (session.getAttribute("settings") != null ? (Properties) session.getAttribute("settings") : new Properties());
	String redirect = props.getProperty("redirect", "");
%>
<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<% if (redirect != "") { %>
        <meta http-equiv="Refresh" content="10; URL=<%=redirect%>">
<% } %>
        <link type="text/css" rel="stylesheet" href="./changepin.css">
        <title>PINsafe Change PIN Complete</title>
    </head>
    <body>
        <table id="box">
            <tr>
                <td class="message">
                    PIN change successful.<br>
<% if (redirect != "") { %>
                    Please wait while you are redirected. If your<br>
                    browser doesn't automatically redirect <br/>
                    click <a href="<%=redirect%>">here</a> to continue.
<% } %>
                </td>
            </tr>
        </table>
    </body>
</html>
<%} %>


